#include "cpluslib/smartptr.h"
#include "cpluslib/assert.h"

#include <map>

#ifdef STREU_CONFIG_DEBUG
bool cpluslib_ptr_initialized = false;
struct InitHelper {
    InitHelper();
    ~InitHelper();
};

InitHelper::InitHelper()
{
    cpluslib_ptr_initialized = true;
}

InitHelper::~InitHelper()
{
    cpluslib_ptr_initialized = false;
}

void cpluslibEnsurePtrValid()
{
    ASSERT(cpluslib_ptr_initialized);
}

static InitHelper init_watch;
#endif

static std::map<void*, ReferenceCount*> reference_map;
ReferenceCount ReferenceCount::null_ref;

ReferenceCount* ReferenceCount::MapPointer(void* p)
{
    if(!p)
        return &ReferenceCount::null_ref;

    std::map<void*, ReferenceCount*>::iterator it =
        reference_map.find(p);
    if(it == reference_map.end()) {
        ReferenceCount* rc = new ReferenceCount;
        rc->ptr_count = 0;
        reference_map[p] = rc;
        return rc;
    } else {
        return it->second;
    }
}
